package net.stepniak.picheese.error.client;

import net.stepniak.picheese.error.client.exception.AuthException;
import net.stepniak.picheese.error.client.exception.ClientBaseException;
import net.stepniak.picheese.error.client.exception.ConnectionFailedException;
import net.stepniak.picheese.error.client.exception.UpdateApplicationException;
import net.stepniak.picheese.error.server.exception.ImageException;

public enum ClientErrorType {
  UPDATE_APPLICATION("You should update application", UpdateApplicationException.class),
  CONNECTION_FAILED("Connection problem, try again", ConnectionFailedException.class),
  AUTH_FAILED("Authentication problem", AuthException.class),
  UPLOAD_FAILED("Unable to send image", ImageException.class),
  ;

  private final String msg;
  private final Class exceptionClass;

  ClientErrorType(String msg, Class exceptionClass) {
    this.msg = msg;
    this.exceptionClass = exceptionClass;
  }

  public String getMsg() {
    return msg;
  }

  public void throwException() throws ClientBaseException {
    if (exceptionClass == UpdateApplicationException.class) {
      throw new UpdateApplicationException(this);
    } else if (exceptionClass == ConnectionFailedException.class) {
      throw new ConnectionFailedException(this);
    }
  }
}
