package net.stepniak.picheese.error.server.exception;

import net.stepniak.picheese.error.server.ServerErrorType;

public abstract class ServerBaseException extends RuntimeException {

  private int status;
  private Throwable cause;
  private ServerErrorType error;

  public ServerBaseException(ServerErrorType error, Throwable cause, int status) {
    super(error.getMsg(), cause);
    this.error = error;
    this.cause = cause;
    this.status = status;
  }

  public Throwable getCause() {
    return cause;
  }

  public ServerErrorType getError() {
    return error;
  }

  public int getStatus() {
    return status;
  }
}